#!/usr/bin/python
# shaboundtable_ss_r1.py:  Table that gives upper bounds on Sha for
#                          semistable elliptic curves of rank 1.
# William Stein, 2002

min = 1
max = 1000

import mfd, time, pari



t0 = time.time()
for N in range(min,max):
    if pari.issquarefree(N):
        M = mfd.ModSym(N,2)
        for E in M.get_iso_classes():
            if E.dimension() == 1 and E.mwrank() == 1:
                code = E.code()
                modp_bound = eval(E.modp_gcd_upper_bound()[1])
                indexes = eval(E.heegner_indexes_odd()[0])[0:5]
                cmd = "indexes=%s;"%indexes+\
                      "g=indexes[1];"\
                      "for(i=2,length(indexes),g=gcd(g,indexes[i]));"\
                      "g;";
                shabound = pari.pari(cmd)
                cp = E.tamagawa_numbers_odd()
                print code,"\t",shabound,"\t",modp_bound,"\t",indexes,"\t",cp

print "total time = ", time.time()-t0
